"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const pipcook_python_node_1 = require("@pipcook/pipcook-python-node");
const assert = __importStar(require("assert"));
const path = __importStar(require("path"));
const imageDetectronModelTrain = (data, model, args) => __awaiter(void 0, void 0, void 0, function* () {
    if (!(data.validationData || data.testData)) {
        return {};
    }
    assert.ok(model && model.config, 'Error! No model path detected');
    const config = model.config;
    let trainer = model.model;
    let evaluationResult = '';
    yield pipcook_python_node_1.Python.scope('detectron', (python) => __awaiter(void 0, void 0, void 0, function* () {
        const _ = python.nA;
        const cfg = python.runRaw(pipcook_python_node_1.Python.convert(config));
        trainer = python.runRaw(pipcook_python_node_1.Python.convert(trainer));
        const [COCOEvaluator, inference_on_dataset] = python.fromImport('detectron2.evaluation', ['COCOEvaluator', 'inference_on_dataset']);
        const [build_detection_test_loader] = python.fromImport('detectron2.data', ['build_detection_test_loader']);
        const evaluator = COCOEvaluator("val_dataset", cfg, false, _({ output_dir: path.join(process.cwd(), '.temp', 'output') }));
        const val_loader = build_detection_test_loader(cfg, "val_dataset");
        const val_result = inference_on_dataset(trainer.model, val_loader, evaluator);
        evaluationResult = yield python.evaluate(val_result);
    }));
    return {
        result: evaluationResult
    };
});
exports.default = imageDetectronModelTrain;
//# sourceMappingURL=index.js.map